//+------------------------------------------------------------------+
//|                                                    Steady-EA.mq4 |
//|                                                      Elitecamper |
//|                                                                  |
//+------------------------------------------------------------------+

// External variables
extern double LotSize = 0.1;
extern double StopLoss = 0;
extern double TakeProfit = 70;

extern int Slippage = 5;
extern int Magic = 123;

extern double TrailingStop = 35;
extern bool trail = True;

// Global variables
int BuyTicket;
int SellTicket;
double UsePoint;
int UseSlippage;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
	{
      UsePoint = PipPoint(Symbol());
      UseSlippage = GetSlippage(Symbol(),Slippage);
	}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
	{
	
	if (trail) trail();
	
		// Moving averages
 double LPFT1 = iCustom(NULL,15,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,0) ;
 double LPFT2 = iCustom(NULL,15,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,1) ;
 
 double LPFT3 = iCustom(NULL,30,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,0) ;
 double LPFT4 = iCustom(NULL,30,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,1) ;
 
 double LPFT5 = iCustom(NULL,60,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,0) ;
 double LPFT6 = iCustom(NULL,60,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,1) ;
 
 double LPFT7 = iCustom(NULL,240,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,0) ;
 double LPFT8 = iCustom(NULL,240,"LowPassFilter_v1",0,3,6,1,0,0,1,1,0,0,0,1) ;

  double dp = iCustom(NULL,0,"Pivot points plus 1.01 EA test",0,0);
  double s1 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",1,0);
  double r1 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",2,0);
  double s2 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",3,0);
  double r2 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",4,0);
  double s3 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",5,0);
  double r3 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",6,0);
  
  double c=iClose(NULL, 15, 1);
  double d=iClose(NULL, 15, 2);
  double e=iClose(NULL, 15, 3);
  double f=iClose(NULL, 15, 4);
  double h=iHigh(NULL, 15, 2);
  double l=iLow(NULL, 15, 2);
  
  double c2=iClose(NULL, 30, 1);
  double d2=iClose(NULL, 30, 2);
  double e2=iClose(NULL, 30, 3);
  double f2=iClose(NULL, 30, 4);
  double h2=iHigh(NULL, 30, 2);
  double l2=iLow(NULL, 30, 2);
  
  double c3=iClose(NULL, 60, 1);
  double d3=iClose(NULL, 60, 2);
  double e3=iClose(NULL, 60, 3);
  double f3=iClose(NULL, 60, 4);
  double h3=iHigh(NULL, 60, 2);
  double l3=iLow(NULL, 60, 2);
  
  double c4=iClose(NULL, 240, 1);
  double d4=iClose(NULL, 240, 2);
  double e4=iClose(NULL, 240, 3);
  double f4=iClose(NULL, 240, 4);
  double h4=iHigh(NULL, 240, 2);
  double l4=iLow(NULL, 240, 2);
  
  double stoch=iStochastic(NULL,0,5,3,3,0,0,0,0);	
  double stoch1=iStochastic(NULL,0,5,3,3,0,0,0,1);	
	
		// Buy order 
		if((f > s1 && e > s1 && l < s1 && c > s1 && LPFT1 > LPFT2) || 
		   (f > s1 && e > s1 && d < s1 && c > s1 && LPFT1 > LPFT2) || 
		   (f2 > s1 && e2 > s1 && l2 < s1 && c2 > s1 && LPFT3 > LPFT4) ||
		   (f2 > s1 && e2 > s1 && d2 < s1 && c2 > s1 && LPFT3 > LPFT4) || 
         (f3 > s1 && e3 > s1 && l3 < s1 && c3 > s1 && LPFT5 > LPFT6) ||
         (f3 > s1 && e3 > s1 && d3 < s1 && c3 > s1 && LPFT5 > LPFT6) ||
         (f4 > s1 && e4 > s1 && l4 < s1 && c4 > s1 && LPFT7 > LPFT8) || 
         (f4 > s1 && e4 > s1 && d4 < s1 && c4 > s1 && LPFT7 > LPFT8) &&
         (stoch < 20 || stoch1 < 20) && BuyTicket == 0)
         
			{
				OrderSelect(SellTicket,SELECT_BY_TICKET);
		
				// Close order
				if(OrderCloseTime() == 0 && SellTicket > 0)
					{
						double CloseLots = OrderLots();
						double ClosePrice = Ask;

						bool Closed = OrderClose(SellTicket,CloseLots,ClosePrice,UseSlippage,Red);
					}				

				double OpenPrice = Ask;
				
				// Calculate stop loss and take profit
				if(StopLoss > 0) double BuyStopLoss = OpenPrice - (StopLoss * UsePoint);
				if(TakeProfit > 0) double BuyTakeProfit = OpenPrice + (TakeProfit * UsePoint);
				
				// Open buy order
				BuyTicket = OrderSend(Symbol(),OP_BUY,LotSize,OpenPrice,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Order",Magic,0,Green);
				
				SellTicket = 0;
			}
		
		
		// Sell Order 
		if((f < r1 && e < r1 && h > r1 && c < r1 && LPFT1 < LPFT2) ||
		   (f < r1 && e < r1 && d > r1 && c < r1 && LPFT1 < LPFT2) || 
		   (f2 < r1 && e2 < r1 && h2 > r1 && c2 < r1 && LPFT3 < LPFT4) || 
		   (f2 < r1 && e2 < r1 && d2 > r1 && c2 < r1 && LPFT3 < LPFT4) || 
         (f3 < r1 && e3 < r1 && h3 > r1 && c3 < r1 && LPFT5 < LPFT6) ||
         (f3 < r1 && e3 < r1 && d3 > r1 && c3 < r1 && LPFT5 < LPFT6) || 
         (f4 < r1 && e4 < r1 && h4 > r1 && c4 < r1 && LPFT7 < LPFT8) ||
         (f4 < r1 && e4 < r1 && d4 > r1 && c4 < r1 && LPFT7 < LPFT8) && 
         (stoch > 80 || stoch1 > 80) && SellTicket == 0)
         
			{
				OrderSelect(BuyTicket,SELECT_BY_TICKET);
		
				if(OrderCloseTime() == 0 && BuyTicket > 0)
					{
						CloseLots = OrderLots();
						ClosePrice = Bid;

						Closed = OrderClose(BuyTicket,CloseLots,ClosePrice,UseSlippage,Red);
					}		
				
				OpenPrice = Bid;
				
				if(StopLoss > 0) double SellStopLoss = OpenPrice + (StopLoss * UsePoint);
				if(TakeProfit > 0) double SellTakeProfit = OpenPrice - (TakeProfit *	UsePoint);
				
				SellTicket = OrderSend(Symbol(),OP_SELL,LotSize,OpenPrice,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Order",Magic,0,Red);
				
				BuyTicket = 0;
			}
			
		return(0);
	}


// Pip Point Function
double PipPoint(string Currency)
	{
		int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
		if(CalcDigits == 2 || CalcDigits == 3) double CalcPoint = 0.01;
		else if(CalcDigits == 4 || CalcDigits == 5) CalcPoint = 0.0001;
		return(CalcPoint);
	}


// Get Slippage Function
int GetSlippage(string Currency, int SlippagePips)
	{
		int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
		if(CalcDigits == 2 || CalcDigits == 4) double CalcSlippage = SlippagePips;
		else if(CalcDigits == 3 || CalcDigits == 5) CalcSlippage = SlippagePips * 10;
		return(CalcSlippage);
	}


void trail() 
{
for (int i = 0; i < OrdersTotal(); i++) 

{
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

if ( OrderSymbol()==Symbol() ) 
{
if (OrderType() == OP_BUY) 
{
if (Bid - OrderOpenPrice() > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
if (OrderStopLoss() < Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
}
}

} else if (OrderType() == OP_SELL) 
{
if (OrderOpenPrice() - Ask > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
if ((OrderStopLoss() > Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) || 
(OrderStopLoss() == 0)) 
{
OrderModify(OrderTicket(), OrderOpenPrice(),
Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red); 
}
}
}
}
}
}



